// {t@C̒쌠́AЃI[Ђі{̒҂ł
// ѓ{ACr[GijɋA܂B
// {t@C𗘗pƂɂ钼ڂ邢͊ԐړIȑQɊւāA
// ҂уI[Ђ͂̐ӔC𕉂˂܂̂ŁA
// 炩߂
// ܂C{t@C𑼂̃EFuTCgŌJ邱ƁCCD-ROMȂǂ
// fBW^fBAōĔzz邱ƁCȂтɔ̔ړIŎgp邱Ƃ
// f肵܂B

// Matrix3NX
// 3x3s̃NX

public class Matrix3 extends MyObject {

	public double a[]; // ɂRR̍s̗vf
	/*
		| a[0] a[1] a[2] |
		| a[3] a[4] a[5] |
		| a[6] a[7] a[8] |
	*/

	// RXgN^
	public Matrix3(double b[]){
		this.a = new double[9];
		for (int i=0;i<9;i++) this.a[i] = b[i];
	}
	public Matrix3( double a0, double a1, double a2,
			double a3, double a4, double a5,
			double a6, double a7, double a8){
		this.a = new double[9];
		this.a[0] = a0; this.a[1] = a1; this.a[2] = a2;
		this.a[3] = a3; this.a[4] = a4; this.a[5] = a5;
		this.a[6] = a6; this.a[7] = a7; this.a[8] = a8;
	}
	public Matrix3(){ // Pʍsŏ
		this.a = new double[9];
		for (int i=0;i<9;i++) this.a[i] = 0.0;
		this.a[0] = this.a[4] = this.a[8] = 1.0;
	}
	public Matrix3(Matrix3 t){ 
		this(t.a);
	}	

	// 3x3s̍s(determinant)̌vZ
	public double determinant(){
		double t =
			a[0]*a[4]*a[8] +
			a[1]*a[5]*a[6] +
			a[2]*a[7]*a[3] -
			a[6]*a[4]*a[2] -
			a[5]*a[7]*a[0] -
			a[8]*a[3]*a[1];
		return t;
	}
	public static double determinant(
		double a0, double a1, double a2,
		double a3, double a4, double a5,
		double a6, double a7, double a8){
		double t =
			a0*a4*a8 +
			a1*a5*a6 +
			a2*a7*a3 -
			a6*a4*a2 -
			a5*a7*a0 -
			a8*a3*a1;
		return t;
	}

	// 3x3sɗxNg
	public Vector3 multiplyVector3(Vector3 v){
		Vector3 w = new Vector3();
		w.x = a[0]*v.x + a[1]*v.y + a[2]*v.z;
		w.y = a[3]*v.x + a[4]*v.y + a[5]*v.z;
		w.z = a[6]*v.x + a[7]*v.y + a[8]*v.z;
		return w;
	}
	public Vector3 multiplyVector3(Matrix3 m, Vector3 v){
		Vector3 w = new Vector3();
		w.x = m.a[0]*v.x + m.a[1]*v.y + m.a[2]*v.z;
		w.y = m.a[3]*v.x + m.a[4]*v.y + m.a[5]*v.z;
		w.z = m.a[6]*v.x + m.a[7]*v.y + m.a[8]*v.z;
		return w;
	}
	public Vertex3 multiplyVertex3(Vertex3 v){
		Vertex3 w = new Vertex3();
		w.x = a[0]*v.x + a[1]*v.y + a[2]*v.z;
		w.y = a[3]*v.x + a[4]*v.y + a[5]*v.z;
		w.z = a[6]*v.x + a[7]*v.y + a[8]*v.z;
		return w;
	}

	// 3x3sb|
	public void multiply(Matrix3 b){
		Matrix3 c = new Matrix3();
		int i,j,k,p,q,r,s;
    		for ( k=0 , p=0, q=0 ; k < 3 ; k++, q += 3 ){
           		for ( j=0 ; j < 3 ; j++ ){
             		r = q;
             		s = j;
             		c.a[p] = 0;
					for ( i=0 ; i < 3 ; i++, r++, s += 3 ){
                   			c.a[p] += b.a[r] * a[s];
              		}
					p++;
         		}
    		}
		for (k = 0; k < 9 ; k++) this.a[k] = c.a[k];
	}

	// 3x3s̋tsvZ
	public Matrix3 inverse() throws SingularMatrixException {
		double t = this.determinant();
		if (Math.abs(t) < EPSILON) 
			throw new SingularMatrixException();
		t = 1.0/t;
		double[] b = new double[9];
		/*
			RRs̋tśA̍s̓]us
			Ƃ̍s̍s񎮂Ŋ́iɒӁj
			|  |a[4] a[5]|   |a[3] a[5]|   |a[3] a[4]| |
			|  |a[7] a[8]|  -|a[6] a[8]|   |a[6] a[7]| |
			|                                          |
			|  |a[1] a[2]|   |a[0] a[2]|   |a[0] a[1]| |
			| -|a[7] a[8]|   |a[6] a[8]|  -|a[6] a[7]| |
			|                                          |
			|  |a[1] a[2]|   |a[0] a[2]|   |a[0] a[1]| |
			|  |a[4] a[5]|  -|a[3] a[5]|   |a[3] a[4]| |
			̂S̗vfȂ| |͂QQs̍s
		*/
 	        b[0] =  (a[4]*a[8]-a[5]*a[7])*t;
        	b[1] = -(a[1]*a[8]-a[7]*a[2])*t;
        	b[2] =  (a[1]*a[5]-a[2]*a[4])*t;
        	b[3] = -(a[3]*a[8]-a[5]*a[6])*t;
        	b[4] =  (a[0]*a[8]-a[2]*a[6])*t;
        	b[5] = -(a[0]*a[5]-a[2]*a[3])*t;
        	b[6] =  (a[3]*a[7]-a[4]*a[6])*t;
        	b[7] = -(a[0]*a[7]-a[1]*a[6])*t;
        	b[8] =  (a[0]*a[4]-a[1]*a[3])*t;
		Matrix3 m = new Matrix3(b);
		return(m);
	}

	// xNg(Vector3)v̎Ɋpxtheta]RRs
	// ]͎xNg̐[猩ĉE
	public Matrix3 rotate(Vector3 v, double theta){
		Vector3 w = new Vector3(v);
		w.normalize();
		double s = Math.sin(theta);
		double c = Math.cos(theta);
		double t = 1-c;
    		a[0] = t*w.x*w.x + c;
    		a[1] = t*w.x*w.y + w.z*s;
    		a[2] = t*w.z*w.x - w.y*s;
    		a[3] = t*w.x*w.y - w.z*s;
    		a[4] = t*w.y*w.y + c;
    		a[5] = t*w.y*w.z + w.x*s;
    		a[6] = t*w.z*w.x + w.y*s;
    		a[7] = t*w.y*w.z - w.x*s;
    		a[8] = t*w.z*w.z + c;
		return this;
	}
	// xNg(dx,dy,dz)̎Ɋpxtheta]RRs
	public Matrix3 rotate(
		double dx, double dy, double dz, double theta){
		Vector3 v = new Vector3(dx,dy,dz);
		return rotate(v,theta);
	}
	public Matrix3 rotate(Vector4 v){
		return rotate(v.x,v.y,v.z,v.w);
	}

	// 3x3s̈
	public void print(){
		System.out.println("Matrix3NX̗vf");
		System.out.println("|"+a[0]+" "+a[1]+" "+a[2]+"|");
		System.out.println("|"+a[3]+" "+a[4]+" "+a[5]+"|");
		System.out.println("|"+a[6]+" "+a[7]+" "+a[8]+"|");
	}
}
